<template>
  <section validation-report>
    <!-- <div badge v-if="validationReport.status === 'success'">
      <md-icon md-src="/img/md/check_circle_outline.svg"/>
      <p>Validation succeeded</p>
    </div>
    <div v-else>
      <div badge>
        <md-icon md-src="/img/md/highlight_off.svg"/>
        <p>Validation failed</p>
      </div>
      <p v-if="validationReport.reason">{{JSON.stringify(validationReport.reason)}}</p>
    </div> -->

    <md-card md-with-hover ref="seeds" :success="seedsValid" :error="!seedsValid">
      <md-ripple>
        <md-card-header @click.native="$refs.seeds.MdCard.expand = !$refs.seeds.MdCard.expand">
          <template v-if="seedsValid">
            <div class="md-title"><md-icon md-src="/img/md/check_circle_outline.svg"/>HLT Seeds &subseteq; L1 Seeds</div>
            <div class="md-subhead">All seeds used in the HLT menu are present in the L1 Menu</div>
          </template>
          <template v-else>
            <div class="md-title"><md-icon md-src="/img/md/highlight_off.svg"/>HLT Seeds &subseteq; L1 Seeds</div>
            <div class="md-subhead">{{getCount('onlyHlt')}} seeds present in the HLT menu are not included in the L1 Menu</div>
          </template>
        </md-card-header>

        <md-card-expand>
          <md-card-expand-content>
            <table>
              <tr>
                <td>Total L1 seeds</td>
                <td>{{validationReport.l1Seeds || 0}}</td>
              </tr>
              <tr>
                <td>Total HLT seeds</td>
                <td>{{validationReport.hltSeeds || 0}}</td>
              </tr>
            </table>
          </md-card-expand-content>
        </md-card-expand>
      </md-ripple>
    </md-card>

    <md-card md-with-hover ref="prescales" :success="prescalesValid" :error="!prescalesValid">
      <md-ripple>
        <md-card-header @click.native="$refs.prescales.MdCard.expand = !$refs.prescales.MdCard.expand">
          <template v-if="prescalesValid">
            <div class="md-title"><md-icon md-src="/img/md/check_circle_outline.svg"/>Prescales match</div>
            <div class="md-subhead">HLT and L1 have the same number of prescale columns</div>
          </template>
          <template v-else>
            <div class="md-title"><md-icon md-src="/img/md/highlight_off.svg"/>Prescales match</div>
            <div class="md-subhead">HLT and L1 have a different number of prescale columns</div>
          </template>
        </md-card-header>

        <md-card-expand>
          <md-card-expand-content>
            <table>
              <tr>
                <th>L1 Prescales ({{getCount('l1Prescales')}})</th>
                <th>HLT Prescales ({{getCount('hltPrescales')}})</th>
              </tr>
              <tr v-for="i in Math.max(getCount('l1Prescales'), getCount('hltPrescales')) || 0" :key="i">
                <td>{{validationReport.l1Prescales[i]}}</td>
                <td>{{validationReport.hltPrescales[i]}}</td>
              </tr>
            </table>
          </md-card-expand-content>
        </md-card-expand>
      </md-ripple>
    </md-card>
  </section>
</template>

<script lang='ts'>
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';

export interface ValidationReport {
  status: 'success' | 'failed';
  l1Seeds: number;
  hltSeeds: number;
  onlyHlt: string[];
  hltPrescales: string[];
  l1Prescales: string[];
}

export interface FailedValidationReport {
  status: 'failed';
  reason: any;
}

@Component({
  components: {
  },
})
export default class extends Vue {

  @Prop()
  private validationReport!: ValidationReport | FailedValidationReport;

  get seedsValid(): boolean {
    if (this.validationReport.status !== 'success') {
      return false;
    }
    return this.validationReport.onlyHlt.length === 0;
  }

  get prescalesValid(): boolean {
    if (this.validationReport.status !== 'success') {
      return false;
    }
    return this.validationReport.l1Prescales.length === this.validationReport.hltPrescales.length;
  }

  private getCount(subject: 'l1Prescales' | 'hltPrescales' | 'onlyHlt'): number {
    if (this.validationReport.status !== 'success') {
      return 0;
    }
    return this.validationReport[subject].length;
  }
}
</script>

<style scoped lang='scss'>
[validation-report] {
  margin: 10px;

  .md-card {
    margin: 0;

    // &[error] {
    //   background: md-get-palette-color(red, 100);
    // }

    .md-card-header {
      .md-title {
        display: flex;
        flex-direction: row;
        align-items: center;
        font-size: 1em;

        .md-icon {
          margin: 5px;
        }
      }
    }

    table {
      margin: 10px;
    }
  }
}
</style>
<style lang='scss'>
[validation-report] {
  .md-card {
    &[success] {
      .md-icon {
        svg {
          fill: md-get-palette-color(green, 600);
        }
      }
    }
    &[error] {
      .md-icon {
        svg {
          fill: md-get-palette-color(red, 600);
        }
      }
    }
  }
}
</style>
